title Word Decrypt
dialog create,Word Decrypt,-1,0,180,60,DLGTYPE(DRAGDROP),-
  STYLE(CSTYLE;;;C),-
  TEXT(T1;10;10;150;30;Opening an encrypted Word for Windows document...;CSTYLE)
DIALOG CURSOR,WAIT
IF @NOT(@FILE(@WINDIR()"\PGP4Word.INI",))
  DIALOG SET, T1, "Creating PGP4Word.ini file in "@WINDIR()
  %J = @dirdlg(Find the Word for Windows directory)
  If @ZERO(%J)
    DIALOG CURSOR
    EXIT
  END
  INIFILE OPEN,@WINDIR()"\PGP4Word.INI"
  INIFILE WRITE,Directory,Word,%J
ELSE
  INIFILE OPEN,@WINDIR()"\PGP4Word.INI"
END
%J = @INIREAD(Directory,Word)
IF @NOT(@FILE(%J,D))
  DIALOG SET, T1, "Updating PGP4Word.ini file in "@WINDIR()
  %J = @dirdlg(Find the Word for Windows directory)
  If @ZERO(%J)
    DIALOG CURSOR
    EXIT
  END
  INIFILE WRITE,Directory,Word,%J
  %J = @INIREAD(Directory,Word)
END
DIALOG SET, T1, Decrypting a Word for Windows document...
DIRECTORY CHANGE, %J
If @ZERO(%1)
  %1 = @file(@filedlg("Encrypted Document file (*.doc.pgp)|*.doc.pgp",Open file),)
  If @ZERO(%1)
    DIALOG CURSOR
    EXIT
  END
END
%L = @file(%1,)
%M = @CHR(34)%L@CHR(34)
%B = %L
IF @EQUAL(@SUBSTR(%L,@DIFF(@LEN(%L),3),@LEN(%L)),".PGP")
  %B = @SUBSTR(%L,1,@DIFF(@LEN(%L),4))
END
IF @NOT(@ASK(Decrypt %M ?))
  DIALOG CURSOR
  EXIT
END
%S = @SHORTNAME(%1)
%P = @PATH(%S)
%N = @NAME(%S)
:passloop
%Z = @INPUT(Enter passphrase:,**********)
IF @EQUAL(%Z,"**********")
  IF @ASK(Are you sure you want to cancel?)
    DIALOG CURSOR
    EXIT
  ELSE
    GOTO passloop
  END
END
DIRECTORY CHANGE, %P
REM Assumes PGPPATH is set, with no trailing slash (e.g. "C:\PGP")
IF @NOT(@FILE(@ENV(PGPPATH),D))
  %K = @dirdlg(Find the PGP directory)
  If @ZERO(%K)
    DIALOG CURSOR
    EXIT
  END
  INIFILE WRITE,Directory,PGP,%K
  %K = @INIREAD(Directory,PGP)
ELSE
  %K = @ENV(PGPPATH)
END
RUN %K\pgp.exe %S -z %Z,WAIT
IF @ZERO(@retcode())
  REM Assumes ZAPFILE is in the Path (mine is)
  RUNH ZAPFILE /3 %S,WAIT
  FILE RENAME,%P%N,%B
  REPEAT
    WAIT 1
  UNTIL @FILE(%B,)
  Shell OPEN,%B
ELSE
  WARN There is a problem: PGP did not decrypt %M as expected
END
DIALOG CURSOR
EXIT
