title Word Encrypt
DIALOG CREATE,Word Encrypt,-1,0,180,60,DLGTYPE(DRAGDROP),-
  STYLE(CSTYLE;;;C),-
  TEXT(T1;10;10;150;30;Encrypting a Word for Windows document...;CSTYLE)
DIALOG CURSOR,WAIT
IF @NOT(@FILE(@WINDIR()"\PGP4Word.INI",))
  DIALOG SET, T1, "Creating PGP4Word.ini file in "@WINDIR()
  %J = @dirdlg(Find the Word for Windows directory)
  If @ZERO(%J)
    DIALOG CURSOR
    EXIT
  END
  INIFILE OPEN,@WINDIR()"\PGP4Word.INI"
  INIFILE WRITE,Directory,Word,%J
ELSE
  INIFILE OPEN,@WINDIR()"\PGP4Word.INI"
END
%J = @INIREAD(Directory,Word)
IF @NOT(@FILE(%J,D))
  DIALOG SET, T1, "Updating PGP4Word.ini file in "@WINDIR()
  %J = @dirdlg(Find the Word for Windows directory)
  If @ZERO(%J)
    DIALOG CURSOR
    EXIT
  END
  INIFILE WRITE,Directory,Word,%J
  %J = @INIREAD(Directory,Word)
END
DIALOG SET, T1, Encrypting a Word for Windows document...
DIRECTORY CHANGE, %J
If @ZERO(%1)
  %1 = @file(@filedlg("Document file to encrypt (*.doc)|*.doc",Open file),)
  If @ZERO(%1)
    DIALOG CURSOR
    EXIT
  END
END
%L = @file(%1,)
%M = @CHR(34)%L@CHR(34)
IF @NOT(@ASK(Encrypt %M ?))
  DIALOG CURSOR
  EXIT
END
%S = @SHORTNAME(%1)
%P = @PATH(%S)
%N = @NAME(%S)
:passloop
%Z = @INPUT(Enter passphrase:,**********)
IF @EQUAL(%Z,"**********")
  IF @ASK(Are you sure you want to cancel?)
    DIALOG CURSOR
    EXIT
  ELSE
    GOTO passloop
  END
END
%Y = @INPUT(Verify passphrase:,**********)
IF @EQUAL(%Y,"**********")
  IF @ASK(Are you sure you want to cancel?)
    DIALOG CURSOR
    EXIT
  ELSE
    GOTO passloop
  END
END
IF @NOT(@EQUAL(%Z,%Y))
  WARN "Passphrases do not match."
  GOTO passloop
END
IF @NOT(@GREATER(@LEN(%Z),9))
  IF @NOT(@EQUAL(%Z,"TEST"))
    WARN "For security reasons, the passphrase must be at least ten characters long."
    WARN "While I have your attention, it's a good idea to put in some random numbers and symbols, too."
    GOTO passloop
  END
END
DIRECTORY CHANGE, %P
REM Assumes PGPPATH is set, with no trailing slash (e.g. "C:\PGP")
IF @NOT(@FILE(@ENV(PGPPATH),D))
  %K = @dirdlg(Find the PGP directory)
  If @ZERO(%K)
    DIALOG CURSOR
    EXIT
  END
  INIFILE WRITE,Directory,PGP,%K
  %K = @INIREAD(Directory,PGP)
ELSE
  %K = @ENV(PGPPATH)
END
REM check to see if shortname already exists, if so, change it
IF @FILE(%P%N".PGP",)
  %D = @datetime(ss)
  %Y = %P"~P4W"%D".TMP"
  FILE RENAME,%S,%Y
  %S = %Y
  %P = @PATH(%S)
  %N = @NAME(%S)
END
RUN %K\pgp.exe -c %S -z %Z,WAIT
IF @ZERO(@retcode())
  REM Assumes ZAPFILE is in the Path (mine is)
  RUNH ZAPFILE /3 %S,WAIT
  FILE RENAME,%P%N".PGP",%L".PGP"
ELSE
  WARN There is a problem: PGP did not encrypt %M as expected
  IF @ASK("Do you want to rename "%S" as "%L"?")
    FILE RENAME,%S,%L
  END
END
%B = @SUBSTR(%L,1,@DIFF(@LEN(%L),4))
%L = %B".WBK"
%U = @LEN(%L)
REPEAT
  %V = @DIFF(%U,1)
  %U = %V
  %X = @SUBSTR(%L,%V,%V)
IF @EQUAL(%X,:)
  DIALOG CURSOR
  EXIT
END
UNTIL @EQUAL(%X,\)
%P = @SUBSTR(%L,1,%V)
%U = @FADD(%U,1)
%N = @SUBSTR(%L,%U,@LEN(%L))
%L = %P"Backup of "%N
IF @FILE(%L,)
  DIALOG SET, T1, Encrypting backup of Word document...
  %M = @CHR(34)%L@CHR(34)
  %S = @SHORTNAME(%L)
  %P = @PATH(%S)
  %N = @NAME(%S)
  IF @NOT(@FILE(@ENV(PGPPATH),D))
    %K = @dirdlg(Find the PGP directory)
    If @ZERO(%K)
      DIALOG CURSOR
      EXIT
    END
    INIFILE WRITE,Directory,PGP,%K
    %K = @INIREAD(Directory,PGP)
  ELSE
    %K = @ENV(PGPPATH)
  END
  REM check to see if shortname already exists, if so, change it
  IF @FILE(%P%N".PGP",)
    %D = @datetime(ss)
    %Y = %P"~P4W"%D".TMP"
    FILE RENAME,%S,%Y
    %S = %Y
    %P = @PATH(%S)
    %N = @NAME(%S)
  END
  RUN %K\pgp.exe -c %S -z %Z,WAIT
  IF @ZERO(@retcode())
    RUNH ZAPFILE /3 %S,WAIT
    FILE RENAME,%P%N".PGP",%L".PGP"
  ELSE
    WARN There is a problem: PGP did not encrypt %M as expected
    IF @ASK("Do you want to rename "%S" as "%L"?")
      FILE RENAME,%S,%L
    END
  END
END
DIALOG CURSOR
EXIT
